Creating a selection filter that finds dynamic blocks in AutoCAD using .NET
http://through-the-interface.typepad.com/through_the_interface/2012/09/crea ... inds-dynamic-blocks-in-autocad-using-net.htmlImports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports System.Collections.Generic
Namespace EntitySelection
Public Class Commands
<CommandMethod("SDB")> _
Public Shared Sub SelectDynamicBlocks()
Dim doc As Object = Application.DocumentManager.MdiActiveDocument
Dim ed As Object = doc.Editor
Dim pso As Object = New PromptStringOptions(vbLf & "Name of dynamic block to search for")
pso.AllowSpaces = True
Dim pr As Object = ed.GetString(pso)
If pr.Status <> PromptStatus.OK Then
Return
End If
Dim blkName As String = pr.StringResult
Dim blkNames As New List(Of String)()
blkNames.Add(blkName)
Dim tr As Object = doc.TransactionManager.StartTransaction()
Using tr
Dim bt As Object = CType(tr.GetObject(doc.Database.BlockTableId, OpenMode.ForRead), BlockTable)
' Start by getting access to our block, if it exists
If Not bt.Has(blkName) Then
ed.WriteMessage(vbLf & "Cannot find block called ""{0}"".", blkName)
Return
End If
' Get the anonymous block names
Dim btr As Object = CType(tr.GetObject(bt(blkName), OpenMode.ForRead), BlockTableRecord)
If Not btr.IsDynamicBlock Then
ed.WriteMessage(vbLf & "Cannot find a dynamic block called ""{0}"".", blkName)
Return
End If
' Get the anonymous blocks and add them to our list
Dim anonBlks As Object = btr.GetAnonymousBlockIds()
For Each bid As ObjectId In anonBlks
Dim btr2 As Object = CType(tr.GetObject(bid, OpenMode.ForRead), BlockTableRecord)
blkNames.Add(btr2.Name)
Next
tr.Commit()
End Using
' Build a conditional filter list so that only
' entities with the specified properties are
' selected
Dim sf As New SelectionFilter(CreateFilterListForBlocks(blkNames))
Dim psr As PromptSelectionResult = ed.SelectAll(sf)
ed.WriteMessage(vbLf & "Found {0} entit{1}.", psr.Value.Count, (If(psr.Value.Count = 1, "y", "ies")))
End Sub
Private Shared Function CreateFilterListForBlocks(ByVal blkNames As List(Of String)) As TypedValue()
' If we don't have any block names, return null
If blkNames.Count = 0 Then
Return Nothing
End If
' If we only have one, return an array of a single value
If blkNames.Count = 1 Then
Return New TypedValue() {New TypedValue(CType(DxfCode.BlockName, Integer), blkNames(0))}
End If
' We have more than one block names to search for...
' Create a list big enough for our block names plus
' the containing "or" operators
Dim tvl As New List(Of TypedValue)(blkNames.Count + 2)
' Add the initial operator
tvl.Add(New TypedValue(CType(DxfCode.[Operator], Integer), "<or"))
' Add an entry for each block name, prefixing the
' anonymous block names with a reverse apostrophe
For Each blkName As Object In blkNames
tvl.Add(New TypedValue(CType(DxfCode.BlockName, Integer), (If(blkName.StartsWith("*"), "`" + blkName, blkName))))
Next
' Add the final operator
tvl.Add(New TypedValue(CType(DxfCode.[Operator], Integer), "or>"))
' Return an array from the list
Return tvl.ToArray()
End Function
End Class
End Namespace
注意到过滤的时候在,匿名块名称上加个点 "`"